class Suc::Mc

  CONFIG_LOCATION = '~/.suflow'

  def initialize
    @errors = []
  end

  def ready?
    configured? ? true : guide!
  end

  def configured?
    config_file_present? && config_valid?
  end

  def guide!
    info = %{
      It seems your client is not configured. That's easy to solve!
      Please visit #{Suc::DEFAULT_URL}, login with your account and populate #{CONFIG_LOCATION}
      with received token.
    }
    puts(info)
    @errors.each{|s| puts(s)}
    exit(1)
  end

  private

  def config_file_present?
    @config_expanded_location = File.expand_path(CONFIG_LOCATION)
    if File.exist?(@config_expanded_location)
      config_content = File.readlines(@config_expanded_location).map(&:chomp)
      Suc.access_token        = config_content[0]
      Suc.email_client        = config_content[1] ? config_content[1] : 'thunderbird'
      Suc.email_recipients    = config_content[2] if config_content[2] # TODO: move recipients from Email back here
      Suc.email_cc_recipients = config_content[3] if config_content[3]
      true
    else
      @errors << "#{@config_expanded_location} is not present"
      false
    end
  end

  def config_valid?
    return true if Suc.access_token && Suc.access_token.length.equal?(24)
    @errors << "Configuration file #{@config_expanded_location} suppose to hold one line with 24 chars"
    false
  end

end
