require 'uri/mailto'

module Suc
  module Reports
    class Email

      def initialize(report)
        @report = report
      end

      def subject
        "Work Report week##{@report.week} #{@report.year}"
      end

      def recipients
        Suc.email_recipients || 'no-reply@example.com'
      end

      def cc_recipients
        Suc.email_cc_recipients
      end

      def export
        headers = { 'subject' => escape(subject), 'body' => escape(@report.body)}
        headers.merge!({ 'cc' => cc_recipients }) if cc_recipients
        escaped_email = URI::MailTo.build({to: recipients, headers: headers}).to_s
        system(Suc.email_client, escaped_email)
      end

      private

      def escape(string)
        URI.escape(string, Regexp.new("[^#{URI::PATTERN::UNRESERVED}]"))
      end

    end
  end
end
