require 'reports/email'

module Suc
  module Reports
    class Personal

      attr_reader :email, :year, :week, :body

      def initialize(year, week, scope='person')
        @week = week
        @year = year
        resource = '/api/years/%s/weeks/%s/messages' % [year, week]
        response = RestClient.get(Suc.resource_url(resource).to_s, { params: { scope: scope }, authorization: Suc.token_auth })
        @messages = Message.from_json(response)
        @email = Email.new(self)
      end

      def grouped_by_color
        @messages.group_by{|x| x.color}.sort_by{|x| x.first.length}
      end

      def print
        file = File.read File.join(File.dirname(__FILE__), '../templates/personal_report.erb')
        template = ERB.new(file, 0, '-<>')
        @body = template.result(binding)
        puts @body
      end

      def export
        email.export
      end

    end
  end
end
